﻿using System;
using System.Windows;
using System.Windows.Forms;
using ELTE.BoardGame.Model;

namespace ELTE.BoardGame.View
{
    /// <summary>
    /// A nézet ősosztálya.
    /// </summary>
    public abstract class BoardGameView : Form
    {
        /// <summary>
        /// Tábla szélessége.
        /// </summary>
        public abstract Int32 BoardWidth { get; }

        /// <summary>
        /// Tábla magassága.
        /// </summary>
        public abstract Int32 BoardHeight { get; }

        /// <summary>
        /// Táblakattintás eseménye.
        /// </summary>
        public event EventHandler<BoardEventArgs> BoardClicked;

        /// <summary>
        /// Megjelenített állapot frissítése.
        /// </summary>
        /// <param name="sessionState">A munkafolyamat állapot.</param>
        public abstract void UpdateViewState(PlayerData[,] sessionState);

        /// <summary>
        /// Táblakattintás eseménykiváltása.
        /// </summary>
        /// <param name="column">Oszlop.</param>
        /// <param name="row">Sor.</param>
        protected void OnBoardClicked(Int32 column, Int32 row)
        {
            if (this.BoardClicked != null)
                this.BoardClicked(this, new BoardEventArgs { Column = column, Row = row });
        }
    }
}
